# Authentication API

## Register
- Endpoint: `/auth/register`
- HTTP Method: `POST`
- Request Body :

```json
{
  "email": "ihsan@gmail.com",
  "password": "abcd1234",
  "role": "lecturer"
}
```

```json
{
  "email": "ihsan@gmail.com",
  "password": "abcd1234",
  "role": "student"
}
```


- Response Body (Success):

```json
{
  "status": 200,
  "message": "Register lecturer successful."
}
```
```json
{
  "status": 200,
  "message": "Register student successful."
}
```

- Response Body (Failure):
```json
{
  "code": 400,
  "status": "Lecturer exist."
}
```
```json
{
  "code": 400,
  "status": "Student exist."
}
```
```json
{
  "status": 400,
  "message": "Role undefined"
 }
```
```json
{
  "code": 500,
  "status": "Register student failed."
}
```
```json
{
  "code": 500,
  "status": "Register lecturer failed."
}
```
## Login
- Endpoint: `/auth/login`
- HTTP Method: `POST`
- Request Body :

```json
{
  "email": "ihsan@gmail.com",
  "password": "some_plain_unhashed_password"
}
```
- Response Body (Success):

```json
{
  "id": "c8205dc9-1fc8-4990-a1a7-41ad047da6d7",
  "email": "ihsan@gmail.com",
  "role": "DEFAULT_USER"
}
```
- Response Body (Failure):
```json
{
  "message": "User email not found!"
}
```
```json
{
  "message": "Password does not match!"
}
```

