# Course API

## Get All Course Data
- Endpoint: `/course/[?facultyId=<facultyId>&majorId=<majorId>&curriculumYear=<curriculumYear>]`
- HTTP Method: `GET`

- Response Body (Success):
```
[
    {
        "id": "2c8595c3-c402-4852-8df9-214a308e65b9",
        "code": "IF5124",
        "name": "Kualitas Perangkat Lunak",
        "type": "WAJIB",
        "credits": 2,
        "defaultSemester": 2,
        "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
        "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
        "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
        "curriculumYear": 2019,
        "createdAt": "2021-04-13T19:51:51.737Z",
        "updatedAt": "2021-04-13T19:51:51.737Z",
        "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
        "Major": {
            "id": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
            "numberCode": 235,
            "name": "Magister Teknik Informatika",
            "createdAt": "2021-04-09T14:56:55.279Z",
            "updatedAt": "2021-04-09T14:56:55.279Z",
            "facultyId": "caf88945-21c7-475a-8ad9-fe1779aa0a11",
            "Faculty": {
                "id": "caf88945-21c7-475a-8ad9-fe1779aa0a11",
                "shortName": "STEI",
                "fullName": "Sekolah Teknik Elektro dan Informatika",
                "createdAt": "2021-04-09T14:56:55.184Z",
                "updatedAt": "2021-04-09T14:56:55.184Z"
            }
        },
        "courseS2": []
    },
    {
        "id": "e1b53710-b8f2-4564-b326-c7f74de81aa2",
        "code": "IF2036",
        "name": "Rekayasa Perangkat Lunak",
        "type": "WAJIB",
        "credits": 3,
        "defaultSemester": 2,
        "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
        "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
        "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
        "curriculumYear": 2013,
        "createdAt": "2021-04-09T15:23:13.444Z",
        "updatedAt": "2021-04-13T19:16:53.968Z",
        "majorId": null,
        "Major": null,
        "courseS2": []
    },
    {
        "id": "e2239de2-afe4-4c99-96ce-2affbfefa259",
        "code": "IF5124",
        "name": "Kualitas Perangkat Lunak",
        "type": "WAJIB",
        "credits": 2,
        "defaultSemester": 2,
        "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
        "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
        "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
        "curriculumYear": 2013,
        "createdAt": "2021-04-13T19:50:56.955Z",
        "updatedAt": "2021-04-13T19:50:56.955Z",
        "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
        "Major": {
            "id": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
            "numberCode": 235,
            "name": "Magister Teknik Informatika",
            "createdAt": "2021-04-09T14:56:55.279Z",
            "updatedAt": "2021-04-09T14:56:55.279Z",
            "facultyId": "caf88945-21c7-475a-8ad9-fe1779aa0a11",
            "Faculty": {
                "id": "caf88945-21c7-475a-8ad9-fe1779aa0a11",
                "shortName": "STEI",
                "fullName": "Sekolah Teknik Elektro dan Informatika",
                "createdAt": "2021-04-09T14:56:55.184Z",
                "updatedAt": "2021-04-09T14:56:55.184Z"
            }
        },
        "courseS2": []
    }
]
```

## Get Course Data by User Id
- Endpoint: `/course/{id}`
- HTTP Method: `GET`

- Response Body (Success):

```json
{
    "id": "517c210a-f35e-4978-ba9f-e38a6addccbd",
    "code": "IF5122",
    "name": "Pembangunan Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan. Topik yang dicakup adalah : Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "createdAt": "2021-02-26T08:00:29.228Z",
    "updatedAt": "2021-02-26T08:00:29.228Z",
    "majorId": "e4a4753d-0413-4494-8c92-35d0dab531a4",
    "Major": {
        "id": "e4a4753d-0413-4494-8c92-35d0dab531a4",
        "numberCode": 235,
        "name": "Magister Teknik Informatika",
        "createdAt": "2021-02-26T08:00:28.830Z",
        "updatedAt": "2021-02-26T08:00:28.830Z",
        "facultyId": "03c1e360-f3c0-4ff1-8296-9cc47f683f77",
        "Faculty": {
            "id": "03c1e360-f3c0-4ff1-8296-9cc47f683f77",
            "shortName": "STEI",
            "fullName": "Sekolah Teknik Elektro dan Informatika",
            "createdAt": "2021-02-26T08:00:28.755Z",
            "updatedAt": "2021-02-26T08:00:28.755Z"
        }
    }
}
```

- Response Body (Failure):
```json
{
    "name": "Error",
    "message": "Object doesn't exist."
}
```
```json
{
    "name": "SequelizeDatabaseError",
    "message": "invalid input syntax for type uuid: \"517c210a-f35e-4978-ba9f-e38a6addccb\""
}
```


## Create Course Data
- Endpoint: `/course`
- HTTP Method: `POST`
- Request Body (for S1 Course):
```json
{
    "code": "IF5124",
    "name": "Kualitas Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db"
}
```

- Response Body (for S1 Course):
```json
{
    "id": "72a0fbf7-0782-4f9f-9295-1716ff466577",
    "code": "IF5124",
    "name": "Kualitas Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
    "updatedAt": "2021-04-13T18:19:08.273Z",
    "createdAt": "2021-04-13T18:19:08.273Z"
}
```

- Request Body (for S2 Course): 
```json
{
    "code": "IF5124",
    "name": "Kualitas Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "optionId": "cd23bb93-81e6-4870-8365-73dbeb8fcf09"
}
```

- Response Body (for S2 Course):
```json
{
    "id": "94867701-bff1-466b-b5a1-fe9b5d3cef97",
    "code": "IF5124",
    "name": "Kualitas Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
    "courseS2": [
        {
            "id": "eb919101-beba-4c50-a84e-459eb9de8dd9",
            "optionId": "cd23bb93-81e6-4870-8365-73dbeb8fcf09",
            "courseId": "94867701-bff1-466b-b5a1-fe9b5d3cef97",
            "updatedAt": "2021-04-13T18:16:59.269Z",
            "createdAt": "2021-04-13T18:16:59.269Z"
        }
    ],
    "updatedAt": "2021-04-13T18:16:59.242Z",
    "createdAt": "2021-04-13T18:16:59.242Z"
}
```

- Request Body (import from previous course): 
```json
{
    "previousId": "e2239de2-afe4-4c99-96ce-2affbfefa259",
    "curriculumYear": 2019
}
```

- Response Body (import from previous course):
```json
{
    "id": "2c8595c3-c402-4852-8df9-214a308e65b9",
    "code": "IF5124",
    "name": "Kualitas Perangkat Lunak",
    "type": "WAJIB",
    "credits": 2,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2019,
    "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db",
    "updatedAt": "2021-04-13T19:51:51.737Z",
    "createdAt": "2021-04-13T19:51:51.737Z"
}
```

- Response Body (Failure):
```json
{
    "name": "SequelizeDatabaseError",
    "message": "invalid input value for enum \"enum_Courses_type\": \"W\""
}
```
```json
{
    "name": "Error",
    "message": "Undefined code,name,type"
}
```


## Update Course Data
- Endpoint: `/course/<id>`
- HTTP Method: `PUT`
- Request Body:
```json
{
    "code": "IF2036",
    "name": "Rekayasa Perangkat Lunak",
    "type": "WAJIB",
    "credits": 3,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013
}
```

- Response Body (Success):
```json
{
    "id": "e1b53710-b8f2-4564-b326-c7f74de81aa2",
    "code": "IF2036",
    "name": "Rekayasa Perangkat Lunak",
    "type": "WAJIB",
    "credits": 3,
    "defaultSemester": 2,
    "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
    "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan.",
    "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
    "curriculumYear": 2013,
    "createdAt": "2021-04-09T15:23:13.444Z",
    "updatedAt": "2021-04-13T19:16:53.968Z",
    "majorId": "10ee3421-21da-46ca-bb2d-c65c9d76b2db"
}
```

- Response Body (Failure):
```json
{
    "name": "SequelizeDatabaseError",
    "message": "invalid input value for enum \"enum_Courses_type\": \"W\""
}
```
```json
{
    "name": "Error",
    "message": "Undefined one of these parameters: code, or name, or type, or credits, or defaultSemester, or shortSyllabus, or completeSyllabus, or outcomes, or curriculumYear"
}
```