# Course Class API

## Get All Course Class Data
- Endpoint: `/course-class/?[status="OPEN"|"CLOSED"&semester=<semester>&startYear=<startYear>&include=<include>&include=<include>]`
- HTTP Method: `GET`
- Include values: `Course`, `Lecturer`, `Students`

- Response Body (Success):
``` json
[
    {
        "id": "b4a2d11c-a0fa-4752-8d38-51e484737e65",
        "startYear": 2021,
        "capacity": 25,
        "participantCount": 0,
        "semester": "1",
        "status": "OPEN",
        "createdAt": "2021-03-22T11:10:35.395Z",
        "updatedAt": "2021-03-22T11:10:35.395Z",
        "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
        "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "courseClassDefaultSchedules": [
            {
                "id": "bc47dc61-8f70-4590-a98c-464d92371f5b",
                "day": "WEDNESDAY",
                "start": "13:00:00",
                "end": "15:00:00",
                "createdAt": "2021-03-22T11:10:35.501Z",
                "updatedAt": "2021-03-22T11:10:35.501Z",
                "courseClassId": "b4a2d11c-a0fa-4752-8d38-51e484737e65"
            }
        ],
        "Course": {
            "id": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
            "code": "IF5122",
            "name": "Pembangunan Perangkat Lunak",
            "type": "WAJIB",
            "credits": 2,
            "defaultSemester": 2,
            "shortSyllabus": "Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review",
            "completeSyllabus": "Pada kuliah ini mahasiswa dibekali dengan prinsip design perangkat lunak yang “baik”, dan menerapkan proses pembangunan (konstruksi) perangkat lunak dalam team, sesuai dengan praktik yang diterapkan di industri dan tools yang banyak digunakan. Topik yang dicakup adalah : Review SDLC dan software methodology, agile methodology, OOAD, Design principles, Component design, Configuration management, Continous integration, Service oriented Design, Code Inspection and Code Review.",
            "outcomes": "Mahasiswa mampu untuk menerapkan prinsip design dalam membangun perangkat lunak, dan membangun perangkat lunak sesuai praktik yang baik (studi kasus).",
            "curriculumYear": 2013,
            "createdAt": "2021-03-22T11:10:35.330Z",
            "updatedAt": "2021-03-22T11:10:35.330Z",
            "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "Major": {
                "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "numberCode": 235,
                "name": "Magister Teknik Informatika",
                "createdAt": "2021-03-22T11:10:34.922Z",
                "updatedAt": "2021-03-22T11:10:34.922Z",
                "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
                "Faculty": {
                    "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
                    "shortName": "STEI",
                    "fullName": "Sekolah Teknik Elektro dan Informatika",
                    "createdAt": "2021-03-22T11:10:34.807Z",
                    "updatedAt": "2021-03-22T11:10:34.807Z"
                }
            }
        },
        "Lecturer": {
            "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nip": null,
            "nik": null,
            "phone": null,
            "academicRole": "KAPRODI",
            "createdAt": "2021-03-22T11:10:35.263Z",
            "updatedAt": "2021-03-22T11:10:35.263Z",
            "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
            "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
        },
        "students": []
    },
    {
        "id": "5ed2ff48-21ab-4152-a857-70faa5d8cfc4",
        "startYear": 2021,
        "capacity": 50,
        "participantCount": 0,
        "semester": "1",
        "status": "OPEN",
        "createdAt": "2021-03-22T11:10:35.395Z",
        "updatedAt": "2021-03-22T11:10:35.395Z",
        "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
        "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "courseClassDefaultSchedules": [
            {
                "id": "84805d46-d4ad-4755-b155-b156689ad096",
                "day": "TUESDAY",
                "start": "09:30:00",
                "end": "11:30:00",
                "createdAt": "2021-03-22T11:10:35.501Z",
                "updatedAt": "2021-03-22T11:10:35.501Z",
                "courseClassId": "5ed2ff48-21ab-4152-a857-70faa5d8cfc4"
            },
            {
                "id": "89386e55-80ad-40f8-bf97-74631e4162cf",
                "day": "THURSDAY",
                "start": "13:00:00",
                "end": "14:00:00",
                "createdAt": "2021-03-22T11:10:35.501Z",
                "updatedAt": "2021-03-22T11:10:35.501Z",
                "courseClassId": "5ed2ff48-21ab-4152-a857-70faa5d8cfc4"
            }
        ],
        "Course": {
            "id": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
            "code": "IF6012",
            "name": "Arsitektur Komputer Lanjut",
            "type": "PILIHAN",
            "credits": 3,
            "defaultSemester": null,
            "shortSyllabus": "Membahas aspek kuantitatif dan kualitatif dari desain arsitektur komputer.",
            "completeSyllabus": "Dasar Desain Komputer, Instruction level parallelism, limits on ILP, multi processor dan thread level parallelism, memory hierarchy design, storage systems.",
            "outcomes": "1. Siswa mampu memahami prinsip dasar arsitektur komputer modern.\n 2. Memahami design tradeoff pada arsitektur komputer.",
            "curriculumYear": 2013,
            "createdAt": "2021-03-22T11:10:35.330Z",
            "updatedAt": "2021-03-22T11:10:35.330Z",
            "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "Major": {
                "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "numberCode": 235,
                "name": "Magister Teknik Informatika",
                "createdAt": "2021-03-22T11:10:34.922Z",
                "updatedAt": "2021-03-22T11:10:34.922Z",
                "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
                "Faculty": {
                    "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
                    "shortName": "STEI",
                    "fullName": "Sekolah Teknik Elektro dan Informatika",
                    "createdAt": "2021-03-22T11:10:34.807Z",
                    "updatedAt": "2021-03-22T11:10:34.807Z"
                }
            }
        },
        "Lecturer": {
            "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nip": null,
            "nik": null,
            "phone": null,
            "academicRole": "KAPRODI",
            "createdAt": "2021-03-22T11:10:35.263Z",
            "updatedAt": "2021-03-22T11:10:35.263Z",
            "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
            "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
        },
        "students": []
    },
    {
        "id": "f52290f5-da7d-4d2b-b230-dd335d6a2247",
        "startYear": 2021,
        "capacity": 50,
        "participantCount": 5,
        "semester": "2",
        "status": "OPEN",
        "createdAt": "2021-03-22T11:10:35.395Z",
        "updatedAt": "2021-03-22T11:10:35.395Z",
        "courseId": "0e3ceed1-d054-4cb4-8396-05ddd58bade8",
        "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "courseClassDefaultSchedules": [
            {
                "id": "d83e98a9-0ec6-446d-af03-2fc9e9120737",
                "day": "MONDAY",
                "start": "07:00:00",
                "end": "09:00:00",
                "createdAt": "2021-03-22T11:10:35.501Z",
                "updatedAt": "2021-03-22T11:10:35.501Z",
                "courseClassId": "f52290f5-da7d-4d2b-b230-dd335d6a2247"
            }
        ],
        "Course": {
            "id": "0e3ceed1-d054-4cb4-8396-05ddd58bade8",
            "code": "IF5010",
            "name": "Sistem & Arsitektur Komputer A",
            "type": "WAJIB",
            "credits": 2,
            "defaultSemester": 1,
            "shortSyllabus": "Memberikan pengetahuan tentang riset dan teknologi sistem arsitektur komputer terkini.",
            "completeSyllabus": "Pembahasan yg lebih dalam dan lanjut tentang modern microprocessors and computer systems, akan dibahas antara lain: Hirarki memory (cache memory, virtual memory, memory management), Instruksi Pipelining.",
            "outcomes": "Mahasiswa diharapkan mampu memahami pengetahuan tentang riset dan teknologi sistem arsitektur komputer.",
            "curriculumYear": 2013,
            "createdAt": "2021-03-22T11:10:35.330Z",
            "updatedAt": "2021-03-22T11:10:35.330Z",
            "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "Major": {
                "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "numberCode": 235,
                "name": "Magister Teknik Informatika",
                "createdAt": "2021-03-22T11:10:34.922Z",
                "updatedAt": "2021-03-22T11:10:34.922Z",
                "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
                "Faculty": {
                    "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
                    "shortName": "STEI",
                    "fullName": "Sekolah Teknik Elektro dan Informatika",
                    "createdAt": "2021-03-22T11:10:34.807Z",
                    "updatedAt": "2021-03-22T11:10:34.807Z"
                }
            }
        },
        "Lecturer": {
            "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nip": null,
            "nik": null,
            "phone": null,
            "academicRole": "KAPRODI",
            "createdAt": "2021-03-22T11:10:35.263Z",
            "updatedAt": "2021-03-22T11:10:35.263Z",
            "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
            "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
        },
        "students": [
            {
                "id": "070d0c07-f741-4358-b90a-8bfe134e0198",
                "userName": null,
                "fullName": null,
                "gender": null,
                "nim": null,
                "nik": null,
                "phone": null,
                "year": null,
                "createdAt": "2021-03-22T11:10:35.287Z",
                "updatedAt": "2021-03-22T11:10:35.287Z",
                "advisorId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
                "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
            }
        ]
    },
    {
        "id": "05fbb599-f2ed-4c87-ac5b-28095dce300c",
        "startYear": 2021,
        "capacity": 50,
        "participantCount": 0,
        "semester": "1",
        "status": "OPEN",
        "createdAt": "2021-03-22T11:10:35.395Z",
        "updatedAt": "2021-03-22T11:10:35.395Z",
        "courseId": "b0686ddc-81e9-4779-9b51-35fe831f916c",
        "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "courseClassDefaultSchedules": [
            {
                "id": "024f186a-0f8d-4592-8bcc-837abb020c33",
                "day": "THURSDAY",
                "start": "13:00:00",
                "end": "15:00:00",
                "createdAt": "2021-03-22T11:10:35.501Z",
                "updatedAt": "2021-03-22T11:10:35.501Z",
                "courseClassId": "05fbb599-f2ed-4c87-ac5b-28095dce300c"
            }
        ],
        "Course": {
            "id": "b0686ddc-81e9-4779-9b51-35fe831f916c",
            "code": "IF6099",
            "name": "Tesis",
            "type": "WAJIB",
            "credits": 6,
            "defaultSemester": 3,
            "shortSyllabus": "Kuliah ini berisi representasi proyek akhir mahasiswa atau Tesis yang bertujuan mengintegrasikan materi yang sudah didapat di perkuliahan.",
            "completeSyllabus": "Menjelaskan dan mengaplikasikan teori, metode, teknik yang relavan pada suatu area yang dipilih, menginterpretasikan data, dan mengambil suatu konklusi/kesimpulan serta saran yang sesuai.",
            "outcomes": "Mahasiswa diharapkan mampu menghasilkan tesis, dan menuliskan sebuah publikasi ilmiah",
            "curriculumYear": 2013,
            "createdAt": "2021-03-22T11:10:35.330Z",
            "updatedAt": "2021-03-22T11:10:35.330Z",
            "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "Major": {
                "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "numberCode": 235,
                "name": "Magister Teknik Informatika",
                "createdAt": "2021-03-22T11:10:34.922Z",
                "updatedAt": "2021-03-22T11:10:34.922Z",
                "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
                "Faculty": {
                    "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
                    "shortName": "STEI",
                    "fullName": "Sekolah Teknik Elektro dan Informatika",
                    "createdAt": "2021-03-22T11:10:34.807Z",
                    "updatedAt": "2021-03-22T11:10:34.807Z"
                }
            }
        },
        "Lecturer": {
            "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nip": null,
            "nik": null,
            "phone": null,
            "academicRole": "KAPRODI",
            "createdAt": "2021-03-22T11:10:35.263Z",
            "updatedAt": "2021-03-22T11:10:35.263Z",
            "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
            "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
        },
        "students": []
    }
]
```
- Response Body (Failure):
```json
{
  "status": 404,
  "message": "Object doesn't exist."
}
```

## Get Course Class Data by Id
- Endpoint: `/course-class/{id}?[include=<include>&include=<include>]`
- HTTP Method: `GET`
- Include values: `Course`, `Lecturer`, `Students`

- Response Body (Success):

```json
{
    "id": "f52290f5-da7d-4d2b-b230-dd335d6a2247",
    "startYear": 2021,
    "capacity": 50,
    "participantCount": 5,
    "semester": "2",
    "status": "OPEN",
    "createdAt": "2021-03-22T11:10:35.395Z",
    "updatedAt": "2021-03-22T11:10:35.395Z",
    "courseId": "0e3ceed1-d054-4cb4-8396-05ddd58bade8",
    "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
    "courseClassDefaultSchedules": [
        {
            "id": "d83e98a9-0ec6-446d-af03-2fc9e9120737",
            "day": "MONDAY",
            "start": "07:00:00",
            "end": "09:00:00",
            "createdAt": "2021-03-22T11:10:35.501Z",
            "updatedAt": "2021-03-22T11:10:35.501Z",
            "courseClassId": "f52290f5-da7d-4d2b-b230-dd335d6a2247"
        }
    ],
    "Course": {
        "id": "0e3ceed1-d054-4cb4-8396-05ddd58bade8",
        "code": "IF5010",
        "name": "Sistem & Arsitektur Komputer A",
        "type": "WAJIB",
        "credits": 2,
        "defaultSemester": 1,
        "shortSyllabus": "Memberikan pengetahuan tentang riset dan teknologi sistem arsitektur komputer terkini.",
        "completeSyllabus": "Pembahasan yg lebih dalam dan lanjut tentang modern microprocessors and computer systems, akan dibahas antara lain: Hirarki memory (cache memory, virtual memory, memory management), Instruksi Pipelining.",
        "outcomes": "Mahasiswa diharapkan mampu memahami pengetahuan tentang riset dan teknologi sistem arsitektur komputer.",
        "curriculumYear": 2013,
        "createdAt": "2021-03-22T11:10:35.330Z",
        "updatedAt": "2021-03-22T11:10:35.330Z",
        "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
        "Major": {
            "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "numberCode": 235,
            "name": "Magister Teknik Informatika",
            "createdAt": "2021-03-22T11:10:34.922Z",
            "updatedAt": "2021-03-22T11:10:34.922Z",
            "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
            "Faculty": {
                "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
                "shortName": "STEI",
                "fullName": "Sekolah Teknik Elektro dan Informatika",
                "createdAt": "2021-03-22T11:10:34.807Z",
                "updatedAt": "2021-03-22T11:10:34.807Z"
            }
        }
    },
    "Lecturer": {
        "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nip": null,
        "nik": null,
        "phone": null,
        "academicRole": "KAPRODI",
        "createdAt": "2021-03-22T11:10:35.263Z",
        "updatedAt": "2021-03-22T11:10:35.263Z",
        "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
        "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
    },
    "students": [
        {
            "id": "070d0c07-f741-4358-b90a-8bfe134e0198",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nim": null,
            "nik": null,
            "phone": null,
            "year": null,
            "createdAt": "2021-03-22T11:10:35.287Z",
            "updatedAt": "2021-03-22T11:10:35.287Z",
            "advisorId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
            "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
            "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
        }
    ]
}
```

- Response Body (Failure):
```json
{
  "status": 404,
  "message": "Object doesn't exist."
}
```

## Create Course Class Data
- Endpoint: `/course-class`
- HTTP Method: `POST`
- Request Body: 
``` json
{
    "courseId": "96178bd6-787a-4641-a4b7-9f954f6b2fca",
    "lecturerId": "e5e6139e-03cc-4fd1-bfca-f14f01d99a13",
    "capacity": 50,
    "participantCount": 20,
    "semester": 2,
    "status": "OPEN",
    "startYear": 2030,
    "courseClassDefaultSchedules" : [
        {
            "day": "MONDAY",
            "start": "13:00:00",
            "end": "15:00:00"
        }
    ]
}
```

- Response Body (Success):
``` json
{
    "id": "9e163d0b-9159-4dc7-addc-84687918cb64",
    "courseId": "96178bd6-787a-4641-a4b7-9f954f6b2fca",
    "lecturerId": "e5e6139e-03cc-4fd1-bfca-f14f01d99a13",
    "startYear": 2030,
    "capacity": 50,
    "participantCount": 20,
    "semester": "2",
    "status": "OPEN",
    "courseClassDefaultSchedules": [
        {
            "id": "6d5889e5-219b-4ab2-ad51-5a054b125280",
            "day": "MONDAY",
            "start": "13:00:00",
            "end": "15:00:00",
            "courseClassId": "a24a7b51-b705-49ea-85fe-e5f9df3f8e97",
            "updatedAt": "2021-03-19T19:12:31.997Z",
            "createdAt": "2021-03-19T19:12:31.997Z"
        }
    ],
    "updatedAt": "2021-03-02T07:12:41.065Z",
    "createdAt": "2021-03-02T07:12:41.065Z"
}
```

- Response Body (Failure):
```json
{
    "name": "SequelizeDatabaseError",
    "message": "invalid input value for enum \"enum_CourseClasses_status\": \"OPENED\""
}
```
```json
{
    "name": "SequelizeDatabaseError",
    "message": "invalid input syntax for type uuid: \"96178bd6-787a-4641-a4b7-9f954f6b2fcaa\""
}
```
```json
{
    "name": "SequelizeForeignKeyConstraintError",
    "message": "insert or update on table \"CourseClasses\" violates foreign key constraint \"CourseClasses_courseId_fkey\""
}
```


## Update Course Class Data

- Endpoint: `/course-class/<id>`
- HTTP Method: `PUT`
- Request Body:

```json
{
    "startYear": 2021,
    "semester": 2,
    "status": "OPEN",
    "capacity": 50,
    "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
    "courseClassDefaultSchedules" : [
        {
            "day": "MONDAY",
            "start": "06:00:00",
            "end": "08:00:00"
        }
    ]
}
```

- Response Body (Success):

```json
{
    "id": "baf859c8-65e7-4930-a44f-48a6a6a741fb",
    "startYear": 2021,
    "capacity": 50,
    "participantCount": 20,
    "semester": "2",
    "status": "OPEN",
    "createdAt": "2021-04-03T10:49:37.416Z",
    "updatedAt": "2021-04-05T19:11:07.408Z",
    "courseId": "b0686ddc-81e9-4779-9b51-35fe831f916c",
    "lecturerId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
    "courseClassDefaultSchedules": [
        {
            "id": "27e7021b-af64-485d-acbf-7988e0dcaf50",
            "day": "MONDAY",
            "start": "06:00:00",
            "end": "08:00:00",
            "createdAt": "2021-04-05T19:11:07.256Z",
            "updatedAt": "2021-04-05T19:11:07.256Z",
            "courseClassId": "baf859c8-65e7-4930-a44f-48a6a6a741fb"
        }
    ]
}
```
