# Course Class Meeting API

## Get Course Class Meeting by Course Class Meeting Id
- Endpoint: `/course-class-meeting/?courseClassMeetingId=<course_class_meeting_id>[&shouldIncludeAttendances="true"|"false"]`
- HTTP Method: `GET`
- Response Body (Success):

```json
{
    "id": "8b3f8b6b-a65b-49ef-a3c0-f14fdf57316a",
    "startTime": "2021-08-17T13:00:00.000Z",
    "endTime": "2021-08-17T15:00:00.000Z",
    "openAttendanceTime": "2021-08-17T13:00:00.000Z",
    "closeAttendanceTime": "2021-08-17T15:00:00.000Z",
    "link": null,
    "topic": null,
    "notes": null,
    "createdAt": "2021-03-22T11:10:35.540Z",
    "updatedAt": "2021-03-22T11:10:35.540Z",
    "courseClassId": "b4a2d11c-a0fa-4752-8d38-51e484737e65",
    "courseClassMeetingAttendances": [
        {
            "status": "ABSENT",
            "Student": {
                "id": "070d0c07-f741-4358-b90a-8bfe134e0198",
                "userName": null,
                "fullName": null,
                "gender": null,
                "nim": null,
                "nik": null,
                "phone": null,
                "year": null,
                "createdAt": "2021-03-22T11:10:35.287Z",
                "updatedAt": "2021-03-22T11:10:35.287Z",
                "advisorId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
                "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
                "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
            }
        }
    ]
}
```

- Response Body (Failure):
```json
{
    "name": "Error",
    "message": "Undefined one of these parameters: courseClassMeetingId, or studentId, or lecturerId"
}
```
```json
{
    "name": "Error",
    "message": "Object doesn't exist."
}
```
## Get Course Class Meeting by Student Id
- Endpoint: `/course-class-meeting/?studentId=<student_id>&semester=<semester>&startYear=<year>`
- HTTP Method: `GET`
- Response Body (Success):

```json
[
    {
        "id": "f599df29-6ac9-4e63-b77b-83a27c15bbb3",
        "startTime": "2021-12-08T13:00:00.000Z",
        "endTime": "2021-12-08T15:00:00.000Z",
        "openAttendanceTime": "2021-12-08T13:00:00.000Z",
        "closeAttendanceTime": "2021-12-08T15:00:00.000Z",
        "CourseClass": {
            "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
            "Course": {
                "code": "IF5122",
                "name": "Pembangunan Perangkat Lunak"
            }
        }
    },
    {
        "id": "f8e192cf-b384-42a1-a187-22a08104350d",
        "startTime": "2021-12-01T13:00:00.000Z",
        "endTime": "2021-12-01T15:00:00.000Z",
        "openAttendanceTime": "2021-12-01T13:00:00.000Z",
        "closeAttendanceTime": "2021-12-01T15:00:00.000Z",
        "CourseClass": {
            "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
            "Course": {
                "code": "IF5122",
                "name": "Pembangunan Perangkat Lunak"
            }
        }
    },
    {
        "id": "dbe564c4-c647-466c-9d3e-bbeabc9180d1",
        "startTime": "2021-12-14T09:30:00.000Z",
        "endTime": "2021-12-14T11:30:00.000Z",
        "openAttendanceTime": "2021-12-14T09:30:00.000Z",
        "closeAttendanceTime": "2021-12-14T11:30:00.000Z",
        "CourseClass": {
            "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
            "Course": {
                "code": "IF6012",
                "name": "Arsitektur Komputer Lanjut"
            }
        }
    },
    {
        "id": "ae5a783d-f89c-4616-a976-cd01e249972f",
        "startTime": "2021-12-07T09:30:00.000Z",
        "endTime": "2021-12-07T11:30:00.000Z",
        "openAttendanceTime": "2021-12-07T09:30:00.000Z",
        "closeAttendanceTime": "2021-12-07T11:30:00.000Z",
        "CourseClass": {
            "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
            "Course": {
                "code": "IF6012",
                "name": "Arsitektur Komputer Lanjut"
            }
        }
    }
]
```

- Response Body (Failure):
```json
{
    "name": "Error",
    "message": "Undefined semester,startYear"
}
```
```json
{
    "name": "Error",
    "message": "Object doesn't exist."
}
```

## Get Course Class Meeting by Lecturer Id
- Endpoint: `/course-class-meeting/?lecturerId=<lecturer_id>&semester=<semester>&startYear=<year>`
- HTTP Method: `GET`
- Response Body (Success):

```json
[
    {
        "id": "33b797f8-6d41-4ad4-b3de-a00dacfb692f",
        "startTime": "2021-08-18T13:00:00.000Z",
        "endTime": "2021-08-18T15:00:00.000Z",
        "openAttendanceTime": "2021-08-18T13:00:00.000Z",
        "closeAttendanceTime": "2021-08-18T15:00:00.000Z",
        "CourseClass": {
            "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
            "Course": {
                "code": "IF5122",
                "name": "Pembangunan Perangkat Lunak"
            }
        }
    },
    {
        "id": "8b3f8b6b-a65b-49ef-a3c0-f14fdf57316a",
        "startTime": "2021-08-17T13:00:00.000Z",
        "endTime": "2021-08-17T15:00:00.000Z",
        "openAttendanceTime": "2021-08-17T13:00:00.000Z",
        "closeAttendanceTime": "2021-08-17T15:00:00.000Z",
        "CourseClass": {
            "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00",
            "Course": {
                "code": "IF5122",
                "name": "Pembangunan Perangkat Lunak"
            }
        }
    },
    {
        "id": "aa9e275b-67a1-426c-a24f-547dea0aeb8a",
        "startTime": "2021-08-19T13:00:00.000Z",
        "endTime": "2021-08-19T15:00:00.000Z",
        "openAttendanceTime": "2021-08-19T13:00:00.000Z",
        "closeAttendanceTime": "2021-08-19T15:00:00.000Z",
        "CourseClass": {
            "courseId": "b0686ddc-81e9-4779-9b51-35fe831f916c",
            "Course": {
                "code": "IF6099",
                "name": "Tesis"
            }
        }
    },
    {
        "id": "99df0561-6962-4335-bff9-fb70369d076c",
        "startTime": "2021-08-18T13:00:00.000Z",
        "endTime": "2021-08-18T15:00:00.000Z",
        "openAttendanceTime": "2021-08-18T13:00:00.000Z",
        "closeAttendanceTime": "2021-08-18T15:00:00.000Z",
        "CourseClass": {
            "courseId": "b0686ddc-81e9-4779-9b51-35fe831f916c",
            "Course": {
                "code": "IF6099",
                "name": "Tesis"
            }
        }
    },
    {
        "id": "dbe564c4-c647-466c-9d3e-bbeabc9180d1",
        "startTime": "2021-12-14T09:30:00.000Z",
        "endTime": "2021-12-14T11:30:00.000Z",
        "openAttendanceTime": "2021-12-14T09:30:00.000Z",
        "closeAttendanceTime": "2021-12-14T11:30:00.000Z",
        "CourseClass": {
            "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
            "Course": {
                "code": "IF6012",
                "name": "Arsitektur Komputer Lanjut"
            }
        }
    },
    {
        "id": "ae5a783d-f89c-4616-a976-cd01e249972f",
        "startTime": "2021-12-07T09:30:00.000Z",
        "endTime": "2021-12-07T11:30:00.000Z",
        "openAttendanceTime": "2021-12-07T09:30:00.000Z",
        "closeAttendanceTime": "2021-12-07T11:30:00.000Z",
        "CourseClass": {
            "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed",
            "Course": {
                "code": "IF6012",
                "name": "Arsitektur Komputer Lanjut"
            }
        }
    }
]
```

- Response Body (Failure):
```json
{
    "name": "Error",
    "message": "Undefined semester,startYear"
}
```
```json
{
    "name": "Error",
    "message": "Object doesn't exist."
}
```

## Update Course Class Meeting

- Endpoint: `/course-class-meeting/<id>`
- HTTP Method: `PUT`
- Request Body:

```json
{
  "link": "https://www.steamcommunity.com/id/icancan",
  "topic": "Code Review",
  "notes": "LGTM",
  "startClass": "2021-08-17T13:15:00.000Z",
  "endClass": "2021-08-17T13:16:00.000Z",
  "startAttendance": "2021-08-17T13:14:59.000Z",
  "endAttendance": "2021-08-17T13:16:01.000Z",
  "attendances": [
    {
      "studentId": "aab0fa6a-b521-4a19-9106-d50cc01e4bf3",
      "status": "PRESENT"
    }
  ]
}
```

- Response Body (Success):

```json
{
  "id": "05351502-c9f4-4dfa-9b39-bd922d28f857",
  "startTime": "2021-08-17T13:15:00.000Z",
  "endTime": "2021-08-17T13:16:00.000Z",
  "openAttendanceTime": "2021-08-17T13:14:59.000Z",
  "closeAttendanceTime": "2021-08-17T13:16:01.000Z",
  "link": "https://www.steamcommunity.com/id/icancan",
  "topic": "Code Review",
  "notes": "LGTM",
  "createdAt": "2021-03-24T19:54:29.567Z",
  "updatedAt": "2021-03-26T07:59:48.401Z",
  "courseClassId": "b973d0d6-ee5a-455d-84f5-1feb35de5df1",
  "courseClassMeetingAttendances": [
    {
      "id": "e84270ff-2332-445c-aa81-7a5662262e9e",
      "status": "PRESENT",
      "Student": {
        "id": "aab0fa6a-b521-4a19-9106-d50cc01e4bf3",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nim": null,
        "nik": null,
        "phone": null,
        "year": null,
        "createdAt": "2021-03-24T19:54:29.472Z",
        "updatedAt": "2021-03-24T19:54:29.472Z",
        "advisorId": "d24cd8e0-fe26-45eb-a8c7-f63d23d8eaf1",
        "majorId": "3013df19-a67d-43d7-a055-09fe3f09fda9",
        "userId": "8cbb6503-1573-4e64-ae1c-f92a3cee5b62"
      }
    }
  ]
}
```
