# Lecturer API

## Get Lecturer Data by User Id
- Endpoint: `/lecturer/{id}`
- HTTP Method: `GET`

- Response Body (Success):

```json
{
    "id": "57e19842-d712-45fd-9068-04cde6bf41f3",
    "userName": "di.aditia",
    "fullName": "Dimas Aditia Pratikto",
    "gender": "M",
    "nip": "1234567890",
    "nik": "1234567890",
    "phone": "0823456789",
    "academicRole": "Kaprodi S2",
    "createdAt": "2021-02-17T03:35:48.279Z",
    "updatedAt": "2021-02-17T03:35:48.279Z",
    "skillGroupId": "57e7cso-su12-4ffd-9j68-djsksbf41f3",
    "userId": "626a872a-7dbf-403a-bca3-83cb9946a9fe",
    "SkillGroup": {
        "id": "23ac049a-698e-4903-9d69-b77f50e8efc7",
        "name": "Rekayasa Perangkat Lunak",
        "createdAt": "2021-03-07T13:02:59.409Z",
        "updatedAt": "2021-03-07T13:02:59.409Z",
        "majorId": "740c43a6-d492-4dca-bbe9-0df84d483ef1",
        "Major": {
            "id": "740c43a6-d492-4dca-bbe9-0df84d483ef1",
            "numberCode": 235,
            "name": "Magister Teknik Informatika",
            "createdAt": "2021-03-07T13:02:59.200Z",
            "updatedAt": "2021-03-07T13:02:59.200Z",
            "facultyId": "893217ad-f9f6-4743-bf94-ebaa7d70d8f0"
        }
    },
    "advisedStudents": [
        {
            "id": "fdde2997-0b05-43ab-8758-d89bf419c347",
            "userName": null,
            "fullName": null,
            "gender": null,
            "nim": null,
            "nik": null,
            "phone": null,
            "year": null,
            "createdAt": "2021-03-07T13:02:59.617Z",
            "updatedAt": "2021-03-07T13:02:59.617Z",
            "advisorId": "85049a17-eba4-41c6-a84a-2b6b6af6b7e4",
            "majorId": "740c43a6-d492-4dca-bbe9-0df84d483ef1",
            "userId": "1de34ca6-967a-44b7-a333-373e0cffb3c0"
        }
    ]
}
```

- Response Body (Failure):
```json
{
  "status": 400,
  "message": "Lecturer doesn't exist."
}
```
```json
{
  "status": 400,
  "message": "Invalid uuid input."
}
```

## Update Lecturer Data by User Id
- Endpoint: `/lecturer/{id}`
- HTTP Method: `PUT`

- Request Body :

```json
{
    "userName": "di.aditia",
    "fullName": "Dimas Aditia Pratikto",
    "gender": "M",
    "nip": "1234567890",
    "nik": "1234567890",
    "phone": "0823456789",
    "academicRole": "Kaprodi S2",
    "skillGroupId": "66b0f70c-94bf-480e-96d0-538c79c0824a"
}
```

- Response Body (Success):

```json
{
    "status": 200,
    "message": "Lecturer data updated."
}
```

- Response Body (Failure):
```json
{
  "status": 400,
  "message": "Lecturer doesn't exist."
}
```
```json
{
  "status": 400,
  "message": "Something wrong with your payload."
}
```

## Get all lecturer
- Endpoint: `/lecturer/[?skillGroups=<skill_group_id_1>&skillGroups=<skill_group_id_2>&..]`
- HTTP Method: `GET`

- Response Body (Success):

```json
[
    {
        "id": "e7a5de85-5d22-4c02-84ec-0fa0655f984c",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nip": null,
        "nik": null,
        "phone": null,
        "academicRole": null,
        "createdAt": "2021-03-06T14:41:51.072Z",
        "updatedAt": "2021-03-06T14:41:51.072Z",
        "skillGroupId": "921eba70-48de-48e4-b86f-04451bc753a2",
        "userId": "5dae3067-023a-4e8b-87d5-f7dd30d5fb5a"
    },
    {
        "id": "87f31cc5-bfd7-4119-925a-c3b2eb624f25",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nip": null,
        "nik": null,
        "phone": null,
        "academicRole": null,
        "createdAt": "2021-03-06T14:41:51.076Z",
        "updatedAt": "2021-03-06T14:41:51.076Z",
        "skillGroupId": "de0de3c1-ac96-41a5-acad-a8ad0766f542",
        "userId": "5dae3067-023a-4e8b-87d5-f7dd30d5fb5a"
    }
]
```
```json
[
    {
        "id": "e7a5de85-5d22-4c02-84ec-0fa0655f984c",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nip": null,
        "nik": null,
        "phone": null,
        "academicRole": null,
        "createdAt": "2021-03-06T14:41:51.072Z",
        "updatedAt": "2021-03-06T14:41:51.072Z",
        "skillGroupId": "921eba70-48de-48e4-b86f-04451bc753a2",
        "userId": "5dae3067-023a-4e8b-87d5-f7dd30d5fb5a"
    }
]
```

- Response Body (Failure):
```json
{
    "name": "Error",
    "message": "Object doesn't exist."
}
```
