# Student API

## Get Student Data by User Id
- Endpoint: `/student/{id}[?includeTranscript="true"|"false"&includeScore="true"|"false"&includeCredits="true"|"false"]`
- HTTP Method: `GET`

- Response Body (Success):

```json
{
    "id": "0a8f5d82-6acd-424c-ae99-a64910303015",
    "userName": "ihsan.ma",
    "fullName": "Ihsan Muhammad Asnadi",
    "gender": "M",
    "nim": "23520301",
    "nik": "12345677777",
    "phone": "0812347890",
    "year": 2020,
    "createdAt": "2021-03-22T11:10:35.287Z",
    "updatedAt": "2021-03-22T11:10:35.287Z",
    "advisorId": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
    "majorId": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
    "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5",
    "Advisor": {
        "id": "a6d2b6b1-7c03-4d9a-a12f-f32809d01639",
        "userName": null,
        "fullName": null,
        "gender": null,
        "nip": null,
        "nik": null,
        "phone": null,
        "academicRole": "KAPRODI",
        "createdAt": "2021-03-22T11:10:35.263Z",
        "updatedAt": "2021-03-22T11:10:35.263Z",
        "skillGroupId": "2d0e4681-d984-4ecb-b57f-b9b92fe6d996",
        "userId": "052b3a5a-d51f-4cb5-ad8e-41ad94803cc5"
    },
    "Major": {
        "id": "476cfe20-e7b2-4537-bdbc-3b76aa226ae3",
        "numberCode": 235,
        "name": "Magister Teknik Informatika",
        "createdAt": "2021-03-22T11:10:34.922Z",
        "updatedAt": "2021-03-22T11:10:34.922Z",
        "facultyId": "f183c826-1b97-4b68-b448-53a0087c8c38",
        "Faculty": {
            "id": "f183c826-1b97-4b68-b448-53a0087c8c38",
            "shortName": "STEI",
            "fullName": "Sekolah Teknik Elektro dan Informatika",
            "createdAt": "2021-03-22T11:10:34.807Z",
            "updatedAt": "2021-03-22T11:10:34.807Z"
        }
    },
    "studyPlans": [
        {
            "id": "94bb4598-d900-4f39-9e63-fd13bbb4c2aa",
            "startYear": 2022,
            "creditsTotal": 0,
            "semester": "2",
            "status": "DRAFT",
            "notes": null,
            "createdAt": "2021-03-22T11:30:01.305Z",
            "updatedAt": "2021-03-22T11:30:01.305Z",
            "studentId": "070d0c07-f741-4358-b90a-8bfe134e0198",
            "studyPlanCourses": []
        },
        {
            "id": "54dbfaa8-1af3-448f-b395-f6f873fdbb5d",
            "startYear": 2022,
            "creditsTotal": 0,
            "semester": "1",
            "status": "FINAL",
            "notes": "LGTM",
            "createdAt": "2021-03-22T11:13:28.237Z",
            "updatedAt": "2021-03-22T11:18:29.776Z",
            "studentId": "070d0c07-f741-4358-b90a-8bfe134e0198",
            "studyPlanCourses": []
        },
        {
            "id": "b5f12832-3ea8-4312-a077-ad26c1d1dc40",
            "startYear": 2021,
            "creditsTotal": 2,
            "semester": "2",
            "status": "FINAL",
            "notes": "LGTM",
            "createdAt": "2021-03-22T11:10:35.457Z",
            "updatedAt": "2021-03-26T06:07:10.417Z",
            "studentId": "070d0c07-f741-4358-b90a-8bfe134e0198",
            "studyPlanCourses": [
                {
                    "id": "de473be6-92bd-4f66-a51a-949d69546ef5",
                    "attendancePercentage": 0,
                    "score": "T",
                    "status": "APPROVED",
                    "createdAt": "2021-03-26T06:07:10.390Z",
                    "updatedAt": "2021-03-26T06:07:10.390Z",
                    "courseClassId": "f52290f5-da7d-4d2b-b230-dd335d6a2247",
                    "studyPlanId": "b5f12832-3ea8-4312-a077-ad26c1d1dc40",
                    "CourseClass": {
                        "courseId": "0e3ceed1-d054-4cb4-8396-05ddd58bade8"
                    }
                }
            ]
        },
        {
            "id": "a9e9a9e8-904b-4af5-8fa2-47ca26bb7ea8",
            "startYear": 2021,
            "creditsTotal": 5,
            "semester": "1",
            "status": "FINAL",
            "notes": "LGTM",
            "createdAt": "2021-03-22T11:10:35.444Z",
            "updatedAt": "2021-03-22T11:10:35.444Z",
            "studentId": "070d0c07-f741-4358-b90a-8bfe134e0198",
            "studyPlanCourses": [
                {
                    "id": "b5f4b392-3a76-4a87-b733-d3730b65f7c9",
                    "attendancePercentage": 0,
                    "score": "A",
                    "status": "APPROVED",
                    "createdAt": "2021-04-06T12:57:16.089Z",
                    "updatedAt": "2021-04-06T12:57:16.089Z",
                    "courseClassId": "5ed2ff48-21ab-4152-a857-70faa5d8cfc4",
                    "studyPlanId": "a9e9a9e8-904b-4af5-8fa2-47ca26bb7ea8",
                    "CourseClass": {
                        "courseId": "937a2f5c-0367-4090-8bc2-c9d9d73e7fed"
                    }
                },
                {
                    "id": "130b3fba-b1d9-4363-88ea-ba68f91914b0",
                    "attendancePercentage": 0,
                    "score": "B",
                    "status": "APPROVED",
                    "createdAt": "2021-04-06T12:57:16.108Z",
                    "updatedAt": "2021-04-06T12:57:16.108Z",
                    "courseClassId": "b4a2d11c-a0fa-4752-8d38-51e484737e65",
                    "studyPlanId": "a9e9a9e8-904b-4af5-8fa2-47ca26bb7ea8",
                    "CourseClass": {
                        "courseId": "6ecf74c5-e667-4ea4-bc95-f535a7b11a00"
                    }
                }
            ]
        }
    ],
    "score": {
        "nr": {
            "2021": {
                "1": 1,
                "2": 0
            }
        },
        "ip": 3.5,
        "ipk": 3.5
    },
    "credits": {
        "passed": 3,
        "scoreT": 2
    }
}
```

- Response Body (Failure):
```json
{
  "status": 400,
  "message": "Student doesn't exist."
}
```
```json
{
  "status": 400,
  "message": "Invalid uuid input."
}
```


## Update Student Data by User Id
- Endpoint: `/student/{id}`
- HTTP Method: `PUT`

- Request Body :

```json
{
    "userName": "di.aditia",
    "fullName": "Dimas Aditia Pratikto",
    "gender": "M",
    "nim": "23520019",
    "nik": "1234567890",
    "phone": "0823456789",
    "year": 2020,
    "advisorId": "57e19842-d712-45fd-9068-04cde6bf41f3",
    "majorId": "b5d5ff39-d8e9-4dda-bd9d-468a9664743c"
}
```

- Response Body (Success):

```json
{
    "status": 200,
    "message": "Student data updated."
}
```

- Response Body (Failure):
```json
{
  "status": 400,
  "message": "Student doesn't exist."
}
```
```json
{
  "status": 400,
  "message": "Something wrong with your payload."
}
```