'use strict';
const {
  handleRequestWithInternalServerError,
  handleRequestWithResourceItemNotFound,
} = require('../util/common');

const {
  getAllOptions
} = require('../util/db/option');

const {
  NotExistError,
} = require('../util/error');


exports.getAllOptions = async (req, res) => {
  const { opts } = req;

  try {
    const options = await getAllOptions(opts);

    res.json(options);
  } catch (error) {
    if (error instanceof NotExistError) {
      handleRequestWithResourceItemNotFound(res, error);
    } else {
      handleRequestWithInternalServerError(res, error);
    }
  }
};