'use strict';

const fs = require('fs');
const path = require('path');
const basename = path.basename(__filename);
const enums = {};

fs.readdirSync(__dirname)
  .filter((file) => {
    return (
      file.indexOf('.') !== 0 && file !== basename && file.slice(-3) === '.js'
    );
  })
  .forEach((file) => {
    const enumFile = require(path.join(__dirname, file));
    enums[enumFile.name] = enumFile.enums;
  });

module.exports = enums;
