'use strict';
const { Op } = require('sequelize');
const { handleRequestWithInvalidRequestBody } = require('../util/common');

const getAllLecturerMiddleware = async (req, res, next) => {
  const { skillGroups = [] } = req.query;

  try {
    let parsedSkillGroups = skillGroups;
    if (typeof skillGroups === 'string' || skillGroups instanceof String) {
      parsedSkillGroups = [skillGroups];
    }

    const skillGroupIds = parsedSkillGroups.map((skillGroupId) => {
      return {
        skillGroupId,
      };
    });

    const opts = {
      where: {},
    };

    if (skillGroupIds.length) {
      opts.where = {
        [Op.or]: skillGroupIds,
      };
    }

    req.body.opts = opts;

    next();
  } catch (error) {
    handleRequestWithInvalidRequestBody(res, error);
  }
};

module.exports = {
  getAllLecturerMiddleware,
};
