const { Lecturer, Major, Faculty } = require('../models/index');

const getStudentMiddleware = async (req, res, next) => {
  const {
    includeTranscript = 'false',
    includeScore = 'false',
    includeCredits = 'false',
  } = req.query;

  const { id } = req.params;

  req.opts = {
    where: {
      userId: id,
    },
  };

  req.opts.include = [
    {
      model: Lecturer,
      as: 'Advisor',
    },
    {
      model: Major,
      include: Faculty,
    },
  ];

  req.includeTranscript = includeTranscript;
  req.includeScore = includeScore;
  req.includeCredits = includeCredits;

  next();
};

module.exports = {
  getStudentMiddleware,
};
