'use strict';

const { getEnumValues } = require('../util/enum');
const { DayEnum } = require('../enums/index');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let days = getEnumValues(DayEnum, 'name');

    await queryInterface.createTable('CourseClassDefaultSchedules', {
      id: {
        allowNull: false,
        primaryKey: true,
        type: Sequelize.UUID,
      },
      day: {
        allowNull: false,
        type: Sequelize.ENUM(days),
      },
      start: {
        type: Sequelize.TIME,
      },
      end: {
        type: Sequelize.TIME,
      },
      courseClassId: {
        type: Sequelize.UUID,
        references: {
          model: 'CourseClasses',
          key: 'id',
        },
        onUpdate: 'CASCADE',
        onDelete: 'CASCADE',
      },
      createdAt: {
        allowNull: false,
        type: Sequelize.DATE,
      },
      updatedAt: {
        allowNull: false,
        type: Sequelize.DATE,
      },
    });
  },
  down: async (queryInterface, Sequelize) => {
    await queryInterface.dropTable('CourseClassDefaultSchedules');
  },
};
