const { v4: uuid_v4 } = require('uuid');
('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class Course extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['Major'], { foreignKey: 'majorId' });
      this.hasMany(models['CourseClass'], {
        foreignKey: 'courseId',
        as: 'classes',
      });
      this.hasMany(models['CourseS2'], {
        foreignKey: 'courseId',
        as: 'courseS2',
      });
    }
  }
  Course.init(
    {
      code: DataTypes.STRING,
      name: DataTypes.STRING,
      type: DataTypes.ENUM(['WAJIB', 'PILIHAN']),
      credits: DataTypes.INTEGER,
      defaultSemester: DataTypes.INTEGER,
      shortSyllabus: DataTypes.TEXT,
      completeSyllabus: DataTypes.TEXT,
      outcomes: DataTypes.TEXT,
      curriculumYear: DataTypes.INTEGER,
    },
    {
      sequelize,
      modelName: 'Course',
    },
  );

  Course.beforeCreate((course) => (course.id = uuid_v4()));
  return Course;
};
