const { v4: uuid_v4 } = require('uuid');
('use strict');
const { Model } = require('sequelize');

const { getEnumValues } = require('../util/enum');
const { DayEnum } = require('../enums/index');

module.exports = (sequelize, DataTypes) => {
  let days = getEnumValues(DayEnum, 'name');

  class CourseClassDefaultSchedule extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['CourseClass'], { foreignKey: 'courseClassId' });
    }
  }
  CourseClassDefaultSchedule.init(
    {
      day: DataTypes.ENUM(days),
      start: DataTypes.TIME,
      end: DataTypes.TIME,
    },
    {
      sequelize,
      modelName: 'CourseClassDefaultSchedule',
    },
  );

  CourseClassDefaultSchedule.beforeCreate(
    (courseClassDefaultSchedule) => (courseClassDefaultSchedule.id = uuid_v4()),
  );
  return CourseClassDefaultSchedule;
};
