const { v4: uuid_v4 } = require('uuid');

('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class CourseClassMeeting extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['CourseClass'], { foreignKey: 'courseClassId' });
      this.hasMany(models['CourseClassMeetingAttendance'], {
        foreignKey: 'courseClassMeetingId',
        as: 'courseClassMeetingAttendances',
      });
    }
  }
  CourseClassMeeting.init(
    {
      startTime: DataTypes.DATE,
      endTime: DataTypes.DATE,
      openAttendanceTime: DataTypes.DATE,
      closeAttendanceTime: DataTypes.DATE,
      link: DataTypes.STRING,
      topic: DataTypes.TEXT,
      notes: DataTypes.TEXT,
    },
    {
      sequelize,
      modelName: 'CourseClassMeeting',
    },
  );

  CourseClassMeeting.beforeCreate(
    (courseClassMeeting) => (courseClassMeeting.id = uuid_v4()),
  );
  return CourseClassMeeting;
};
