const { v4: uuid_v4 } = require('uuid');

('use strict');
const { Model } = require('sequelize');

const { getEnumValues } = require('../util/enum');
const { AttendanceStatusEnum } = require('../enums/index');

module.exports = (sequelize, DataTypes) => {
  let attendanceStatuses = getEnumValues(AttendanceStatusEnum);

  class CourseClassMeetingAttendance extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['CourseClassMeeting'], {
        foreignKey: 'courseClassMeetingId',
      });
      this.belongsTo(models['Student'], { foreignKey: 'studentId' });
    }
  }
  CourseClassMeetingAttendance.init(
    {
      status: DataTypes.ENUM(attendanceStatuses),
    },
    {
      sequelize,
      modelName: 'CourseClassMeetingAttendance',
    },
  );

  CourseClassMeetingAttendance.beforeCreate(
    (courseClassMeetingAttendance) =>
      (courseClassMeetingAttendance.id = uuid_v4()),
  );
  return CourseClassMeetingAttendance;
};
