const { v4: uuid_v4 } = require('uuid');

('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class Faculty extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.hasMany(models['Major'], { foreignKey: 'facultyId', as: 'majors' });
    }
  }
  Faculty.init(
    {
      shortName: DataTypes.STRING,
      fullName: DataTypes.STRING,
    },
    {
      sequelize,
      modelName: 'Faculty',
    },
  );

  Faculty.beforeCreate((faculty) => (faculty.id = uuid_v4()));
  return Faculty;
};
