const { v4: uuid_v4 } = require('uuid');

('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class Major extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['Faculty'], { foreignKey: 'facultyId' });
      this.hasMany(models['SkillGroup'], {
        foreignKey: 'majorId',
        as: 'skillGroups',
      });
      this.hasMany(models['Student'], {
        foreignKey: 'majorId',
        as: 'students',
      });
      this.hasMany(models['Course'], { foreignKey: 'majorId', as: 'courses' });
      this.hasMany(models['Option'], { foreignKey: 'majorId', as: 'options' });
    }
  }
  Major.init(
    {
      numberCode: DataTypes.INTEGER,
      name: DataTypes.STRING,
    },
    {
      sequelize,
      modelName: 'Major',
    },
  );

  Major.beforeCreate((major) => (major.id = uuid_v4()));
  return Major;
};
