const { v4: uuid_v4 } = require('uuid');
('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class Option extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['Major'], { foreignKey: 'majorId' });
      this.hasMany(models['CourseS2'], {
        foreignKey: 'optionId',
        as: 'courses',
      });
      this.hasMany(models['StudentS2'], {
        foreignKey: 'optionId',
        as: 'students',
      });
    }
  }
  Option.init(
    {
      name: DataTypes.STRING,
    },
    {
      sequelize,
      modelName: 'Option',
    },
  );

  Option.beforeCreate((option) => (option.id = uuid_v4()));
  return Option;
};
