const { v4: uuid_v4 } = require('uuid');
('use strict');
const { Model } = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class SkillGroup extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      this.belongsTo(models['Major'], { foreignKey: 'majorId' });
      this.hasMany(models['Lecturer'], {
        foreignKey: 'skillGroupId',
        as: 'lecturers',
      });
    }
  }
  SkillGroup.init(
    {
      name: DataTypes.STRING,
    },
    {
      sequelize,
      modelName: 'SkillGroup',
    },
  );

  SkillGroup.beforeCreate((skillGroup) => (skillGroup.id = uuid_v4()));
  return SkillGroup;
};
