const { v4: uuid_v4 } = require('uuid');
('use strict');
const { Model } = require('sequelize');

module.exports = (sequelize, DataTypes) => {
  class User extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      // define association here
    }
  }
  User.init(
    {
      email: DataTypes.STRING,
      hashed_password: DataTypes.STRING,
      salt: DataTypes.STRING,
      role: DataTypes.ENUM(['ADMIN', 'DEFAULT_USER']),
    },
    {
      sequelize,
      modelName: 'User',
    },
  );

  User.beforeCreate((user) => (user.id = uuid_v4()));

  return User;
};
