const express = require('express');
const router = express.Router();

const courseClassMeeting = require('../controllers/course-class-meeting');
const {
  getCourseClassMeetingMiddleware,
  updateCourseClassMeetingBodyCheckerMiddleware,
  updateCourseClassMeetingMiddleware,
} = require('../middleware/course-class-meeting');

router.get('/', getCourseClassMeetingMiddleware);
router.get('/', courseClassMeeting.getCourseClassMeeting);

router.put('/:id', updateCourseClassMeetingBodyCheckerMiddleware);
router.put('/:id', updateCourseClassMeetingMiddleware);
router.put('/:id', courseClassMeeting.updateCourseClassMeeting);

module.exports = router;
