var express = require('express');
var router = express.Router();

var courseController = require('../controllers/course');

const {
  createCourseMiddleware,
  updateCourseMiddleware,
  getAllCoursesMiddleware
} = require('../middleware/course');

// GET request to get all faculty data
router.get('/', getAllCoursesMiddleware);
router.get('/', courseController.getAllCourseData);

// GET request to get course data by id
router.get('/:id', courseController.getCourseData);

router.post('/', createCourseMiddleware);
router.post('/', courseController.createCourseData);

router.put('/:id', updateCourseMiddleware);
router.put('/:id', courseController.updateCourseData);

module.exports = router;
