const express = require('express');
const router = express.Router();

const courseclass = require('../controllers/courseclass');
const {
  getCourseClassMiddleware,
  updateCourseClassMiddleware,
} = require('../middleware/course-class');

router.post('/', courseclass.createCourseClassData);

// GET request to get all course class data (can use filter)
router.get('/', getCourseClassMiddleware);
router.get('/', courseclass.getCourseClassData);

// GET request to get course class data by id (can use filter)
router.get('/:id', getCourseClassMiddleware);
router.get('/:id', courseclass.getCourseClassData);

// PUT request to update course class data
router.put('/:id', updateCourseClassMiddleware);
router.put('/:id', courseclass.updateCourseClass);

module.exports = router;
