var express = require('express');
var router = express.Router();

var studyPlan = require('../controllers/study-plan');
const {
  getStudyPlanMiddleware,
  updateStudyPlanMiddleware,
} = require('../middleware/study-plan');

// POST request to create study plan data
router.post('/', studyPlan.createStudyPlanData);

router.get('/', getStudyPlanMiddleware);
router.get('/', studyPlan.getStudyPlan);

router.put('/:id', updateStudyPlanMiddleware);
router.put('/:id', studyPlan.updateStudyPlan);

module.exports = router;
