const { v4: uuid_v4 } = require('uuid');
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();
    await queryInterface.bulkInsert(
      'Faculties',
      [
        {
          id: uuid_v4(),
          shortName: 'STEI',
          fullName: 'Sekolah Teknik Elektro dan Informatika',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          shortName: 'FTI',
          fullName: 'Fakultas Teknik Industri',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          shortName: 'FTTM',
          fullName: 'Fakultas Teknik Pertambangan dan Perminyakan',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          shortName: 'SF',
          fullName: 'Sekolah Farmasi',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          shortName: 'SBM',
          fullName: 'Sekolah Bisnis dan Manajemen',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          shortName: 'FITB',
          fullName: 'Fakultas Ilmu dan Teknologi Kebumian',
          createdAt: date,
          updatedAt: date,
        },
      ],
      {},
    );
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('Faculties', null, {});
  },
};
