const { v4: uuid_v4 } = require('uuid');
const Faculty = require('../models/index')['Faculty'];

('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const stei = await Faculty.findOne({
      where: {
        shortName: 'STEI',
      },
    });

    const fti = await Faculty.findOne({
      where: {
        shortName: 'FTI',
      },
    });

    await queryInterface.bulkInsert(
      'Majors',
      [
        {
          id: uuid_v4(),
          numberCode: '135',
          name: 'Sarjana Teknik Informatika',
          facultyId: stei.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          numberCode: '182',
          name: 'Sarjana Sistem Teknologi dan Informasi',
          facultyId: stei.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          numberCode: '235',
          name: 'Magister Teknik Informatika',
          facultyId: stei.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          numberCode: '123',
          name: 'Sarjana Teknik Industri',
          facultyId: fti.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          numberCode: '223',
          name: 'Magister Teknik Industri',
          facultyId: fti.id,
          createdAt: date,
          updatedAt: date,
        },
      ],
      {},
    );
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('Majors', null, {});
  },
};
