const { v4: uuid_v4 } = require('uuid');
const Major = require('../models/index')['Major'];
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const masterIF = await Major.findOne({
      where: {
        numberCode: 235,
      },
    });

    const bachelorIF = await Major.findOne({
      where: {
        numberCode: 135,
      },
    });

    await queryInterface.bulkInsert(
      'SkillGroups',
      [
        {
          id: uuid_v4(),
          name: 'Rekayasa Perangkat Lunak',
          majorId: masterIF.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          name: 'Sistem Intelijen',
          majorId: masterIF.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          name: 'Sistem Informasi',
          majorId: bachelorIF.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          name: 'Software Engineering',
          majorId: bachelorIF.id,
          createdAt: date,
          updatedAt: date,
        },
      ],
      {},
    );
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('SkillGroups', null, {});
  },
};
