const { v4: uuid_v4 } = require('uuid');
const { Course, Option } = require('../models/index');
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const rpl = await Option.findOne({
      where: {
        name: 'Rekayasa Perangkat Lunak',
      },
    });

    const sintel = await Option.findOne({
      where: {
        name: 'Sistem Intelijen',
      },
    });

    const sinfo = await Option.findOne({
      where: {
        name: 'Sistem Informasi',
      },
    });

    const bi = await Option.findOne({
      where: {
        name: 'Intelijen Bisnis',
      },
    });

    const ppl = await Course.findOne({
      where: {
        code: 'IF5122',
      },
    });

    const arsikomA = await Course.findOne({
      where: {
        code: 'IF5010',
      },
    });

    const tesis = await Course.findOne({
      where: {
        code: 'IF6099',
      },
    });

    await queryInterface.bulkInsert(
      'CourseS2s',
      [
        {
          id: uuid_v4(),
          courseId: ppl.id,
          optionId: rpl.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: arsikomA.id,
          optionId: rpl.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: arsikomA.id,
          optionId: sintel.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: tesis.id,
          optionId: rpl.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: tesis.id,
          optionId: sintel.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: tesis.id,
          optionId: sinfo.id,
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: tesis.id,
          optionId: bi.id,
          createdAt: date,
          updatedAt: date,
        },
      ],
      {},
    );
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('CourseS2s', null, {});
  },
};
