const { v4: uuid_v4 } = require('uuid');
const { Course, User, Lecturer } = require('../models/index');
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const user = await User.findOne({
      where: {
        email: 'ihsan@gmail.com',
      },
    });

    const lecturer = await Lecturer.findOne({
      where: {
        userId: user.id,
      },
    });

    const ppl = await Course.findOne({
      where: {
        code: 'IF5122',
      },
    });

    const arsikomA = await Course.findOne({
      where: {
        code: 'IF5010',
      },
    });

    const tesis = await Course.findOne({
      where: {
        code: 'IF6099',
      },
    });

    const advancedArsikom = await Course.findOne({
      where: {
        code: 'IF6012',
      },
    });

    await queryInterface.bulkInsert(
      'CourseClasses',
      [
        {
          id: uuid_v4(),
          courseId: ppl.id,
          lecturerId: lecturer.id,
          startYear: 2021,
          capacity: 25,
          participantCount: 0,
          semester: '1',
          status: 'OPEN',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: arsikomA.id,
          lecturerId: lecturer.id,
          startYear: 2021,
          capacity: 50,
          participantCount: 5,
          semester: '2',
          status: 'OPEN',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: tesis.id,
          lecturerId: lecturer.id,
          startYear: 2021,
          capacity: 50,
          participantCount: 0,
          semester: '1',
          status: 'OPEN',
          createdAt: date,
          updatedAt: date,
        },
        {
          id: uuid_v4(),
          courseId: advancedArsikom.id,
          lecturerId: lecturer.id,
          startYear: 2021,
          capacity: 50,
          participantCount: 0,
          semester: '1',
          status: 'OPEN',
          createdAt: date,
          updatedAt: date,
        },
      ],
      {},
    );
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('CourseClasses', null, {});
  },
};
