const { User, Student, StudyPlan } = require('../models/index');

const { StudyPlanStatusEnum } = require('../enums/index');
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    const user = await User.findOne({
      where: {
        email: 'ihsan@gmail.com',
      },
    });

    const student = await Student.findOne({
      where: {
        userId: user.id,
      },
    });

    await StudyPlan.create({
      studentId: student.id,
      startYear: 2021,
      semester: '1',
      notes: 'LGTM',
      status: StudyPlanStatusEnum.FINAL,
    });

    await StudyPlan.create({
      studentId: student.id,
      startYear: 2021,
      semester: '2',
      notes: 'LGTM',
    });
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('StudyPlans', null, {});
  },
};
