const { v4: uuid_v4 } = require('uuid');
const {
  StudyPlanCourseStatusEnum,
  ScoreStatusEnum,
} = require('../enums/index');

const { StudyPlan, Course, CourseClass } = require('../models/index');
('use strict');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const studyPlan = await StudyPlan.findOne({
      where: {
        semester: '1',
      },
    });

    const ppl = await Course.findOne({
      where: {
        code: 'IF5122',
      },
    });
    const advancedArsikom = await Course.findOne({
      where: {
        code: 'IF6012',
      },
    });

    const pplClass = await CourseClass.findOne({
      where: {
        courseId: ppl.id,
      },
    });

    const advancedArsikomClass = await CourseClass.findOne({
      where: {
        courseId: advancedArsikom.id,
      },
    });

    await queryInterface.bulkInsert('StudyPlanCourses', [
      {
        id: uuid_v4(),
        studyPlanId: studyPlan.id,
        courseClassId: pplClass.id,
        status: StudyPlanCourseStatusEnum.UNAPPROVED,
        scoreStatus: ScoreStatusEnum.DRAFT,
        createdAt: date,
        updatedAt: date,
      },
      {
        id: uuid_v4(),
        studyPlanId: studyPlan.id,
        courseClassId: advancedArsikomClass.id,
        status: StudyPlanCourseStatusEnum.UNAPPROVED,
        scoreStatus: ScoreStatusEnum.DRAFT,
        createdAt: date,
        updatedAt: date,
      },
    ]);
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('StudyPlanCourses', null, {});
  },
};
