const { v4: uuid_v4 } = require('uuid');
const { DayEnum } = require('../enums/index');

('use strict');
const { Course, CourseClass } = require('../models/index');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    let date = new Date();

    const ppl = await Course.findOne({
      where: {
        code: 'IF5122',
      },
    });

    const advancedArsikom = await Course.findOne({
      where: {
        code: 'IF6012',
      },
    });

    const arsikomA = await Course.findOne({
      where: {
        code: 'IF5010',
      },
    });

    const tesis = await Course.findOne({
      where: {
        code: 'IF6099',
      },
    });

    const pplClass = await CourseClass.findOne({
      where: {
        courseId: ppl.id,
      },
    });

    const advancedArsikomClass = await CourseClass.findOne({
      where: {
        courseId: advancedArsikom.id,
      },
    });

    const arsikomAClass = await CourseClass.findOne({
      where: {
        courseId: arsikomA.id,
      },
    });

    const tesisClass = await CourseClass.findOne({
      where: {
        courseId: tesis.id,
      },
    });

    await queryInterface.bulkInsert('CourseClassDefaultSchedules', [
      {
        id: uuid_v4(),
        courseClassId: pplClass.id,
        day: DayEnum.WEDNESDAY.name,
        start: '13:00:00',
        end: '15:00:00',
        createdAt: date,
        updatedAt: date,
      },
      {
        id: uuid_v4(),
        courseClassId: advancedArsikomClass.id,
        day: DayEnum.TUESDAY.name,
        start: '09:30:00',
        end: '11:30:00',
        createdAt: date,
        updatedAt: date,
      },
      {
        id: uuid_v4(),
        courseClassId: advancedArsikomClass.id,
        day: DayEnum.THURSDAY.name,
        start: '13:00:00',
        end: '14:00:00',
        createdAt: date,
        updatedAt: date,
      },
      {
        id: uuid_v4(),
        courseClassId: arsikomAClass.id,
        day: DayEnum.MONDAY.name,
        start: '07:00:00',
        end: '09:00:00',
        createdAt: date,
        updatedAt: date,
      },
      {
        id: uuid_v4(),
        courseClassId: tesisClass.id,
        day: DayEnum.THURSDAY.name,
        start: '13:00:00',
        end: '15:00:00',
        createdAt: date,
        updatedAt: date,
      },
    ]);
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('CourseClassDefaultSchedules', null, {});
  },
};
