'use strict';
const { StudyPlan } = require('../models/index');

const { StudyPlanStatusEnum } = require('../enums/index');

const { generateCourseClassMeetingAttendances } = require('../util/common');

module.exports = {
  up: async (queryInterface, Sequelize) => {
    const studyPlans = await StudyPlan.findAll({
      where: {
        status: StudyPlanStatusEnum.FINAL,
      },
    });

    for (let i = 0; i < studyPlans.length; i++) {
      await generateCourseClassMeetingAttendances(studyPlans[i]);
    }
  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.bulkDelete('CourseClassMeetingAttendances', null, {});
  },
};
