const Faculty = require('../models/index')['Faculty'];

let chai = require('chai');
let chaiHttp = require('chai-http');
let server = require('../index');
let should = chai.should();

chai.use(chaiHttp);

let SHORT_NAME = 'FSRD';
let FULL_NAME = 'Fakultas Seni Rupa dan Desain';

describe('Faculty Test', () => {
  beforeEach(async () => {
    await Faculty.destroy({ where: {} });
  });

  afterEach(() => {
    server.close();
  });

  describe('/GET faculty', () => {
    beforeEach(async () => {
      let faculty = await Faculty.create({
        shortName: SHORT_NAME,
        fullName: FULL_NAME,
      });
    });

    it('should get all faculties data', (done) => {
      chai
        .request(server)
        .get('/faculty')
        .end((err, res) => {
          res.should.have.status(200);
          chai.expect(res.body).to.be.an('array');
          chai.expect(res.body[0]).to.have.property('shortName', SHORT_NAME);
          chai.expect(res.body[0]).to.have.property('fullName', FULL_NAME);
          done();
        });
    });
  });
});
