'use strict';
const { User } = require('../models/index');

const {
  PasswordDoesntMatchError,
  EmailNotFoundError,
} = require('../util/error');
const { hashPasswordGivenSalt } = require('../util/salt');

const getUser = async (email, password) => {
  const foundUser = await User.findOne({
    where: {
      email,
    },
  });

  if (!foundUser) throw new EmailNotFoundError();

  const hashedPassword = await hashPasswordGivenSalt(password, foundUser.salt);
  if (foundUser.hashed_password !== hashedPassword)
    throw new PasswordDoesntMatchError();

  return foundUser;
};

module.exports = {
  getUser,
};
