'use strict';
const {
  Option,
} = require('../../models/index');

const {
  NotExistError,
} = require('../error');

const getAllOptions = async (opts = {}) => {
  const options = await Option.findAll(opts);

  if (!options || options.length === 0) throw new NotExistError();

  return options;
};

const getOption = async (opts = {}) => {
  const option = await Option.findOne(opts);

  if (!option) throw new NotExistError();

  return option;
};

module.exports = {
  getAllOptions,
  getOption
};