'use strict';

class PasswordDoesntMatchError extends Error {
  constructor() {
    super('Password does not match!');
  }
}

class EmailNotFoundError extends Error {
  constructor() {
    super('User email not found!');
  }
}

class InvalidRequestBodyError extends Error {
  constructor() {
    super('There is something wrong with your request.');
  }
}

class NotExistError extends Error {
  constructor() {
    super("Object doesn't exist.");
  }
}

class ClassUnavailableError extends Error {
  constructor() {
    super('Some of course classes are unavailable.');
  }
}

class RequiredParameterUndefinedError extends Error {
  constructor(params) {
    super('Undefined ' + params);
  }
}

class StudyPlanExistError extends Error {
  constructor() {
    super("Study plan's already exist");
  }
}

class CourseExistError extends Error {
  constructor() {
    super("Course's already exist");
  }
}

class LecturerNotFoundError extends NotExistError {
  constructor() {
    super('Lecturer not found!');
  }
}


module.exports = {
  PasswordDoesntMatchError,
  EmailNotFoundError,
  InvalidRequestBodyError,
  NotExistError,
  ClassUnavailableError,
  RequiredParameterUndefinedError,
  StudyPlanExistError,
  LecturerNotFoundError,
  CourseExistError
};
