'use strict';
const bcrypt = require('bcrypt');
const saltRounds = require(__dirname + '/../config/hash.json')['saltRounds'];

const hashPasswordGivenSalt = async (password, salt) => {
  const hashedPassword = await bcrypt.hash(password, salt);

  return hashedPassword;
};

const hashPasswordWithoutSalt = async (password) => {
  const salt = await bcrypt.genSalt(saltRounds);
  const hashedPassword = await hashPasswordGivenSalt(password, salt);

  return {
    salt,
    hashedPassword,
  };
};

module.exports = {
  hashPasswordGivenSalt,
  hashPasswordWithoutSalt,
};
