/* User */
import { createRouter, createWebHistory } from "vue-router";
import Authentication from "../views/Authentication/Authentication";
import AuthenticationManual from "../views/Authentication/AuthenticationManual";
import CourseEnrollment from "../views/CourseEnrollment/CourseEnrollment";
import SelectCourse from "../views/CourseEnrollment/SelectCourse";
import Curriculum from "../views/Curriculum/Curriculum";
import Syllabus from "../views/Curriculum/Syllabus";
import EnrollmentType from "../views/CourseEnrollment/EnrollmentType";
import LectureSchedule from "../views/LectureSchedule/LectureSchedule";
import CreateEditSchedule from "../views/LectureSchedule/CreateEditSchedule";
import Profile from "../views/Profile/Profile";
import StudentStatus from "../views/StudentStatus/StudentStatus";
import StudyProgression from "../views/StudyProgression/StudyProgression";
import CourseAssessment from "../views/CourseAssessment/CourseAssessment";
import CreateEditAssessment from "../views/CourseAssessment/CreateEditAssessment";
import NotFound from "../views/NotFound/NotFound";

/* Admin */
import CreateEditClass from "../views/CourseEnrollment/CreateEditClass";
import CurriculumAdmin from "../views/Curriculum/CurriculumAdmin";
import ManageCurriculum from "../views/Curriculum/ManageCurriculum";

const routes = [
  {
    path: "/authentication",
    name: "Authentication",
    component: Authentication
  },
  {
    path: "/authentication-manual",
    name: "AuthenticationManual",
    component: AuthenticationManual
  },
  {
    path: "/course-enrollment",
    name: "CourseEnrollment",
    component: CourseEnrollment
  },
  {
    path: "/select-course",
    name: "SelectCourse",
    component: SelectCourse
  },
  {
    path: "/create-edit-class",
    name: "CreateEditClass",
    component: CreateEditClass
  },
  {
    path: "/curriculum",
    name: "Curriculum",
    component: Curriculum
  },
  {
    path: "/manage-curriculum",
    name: "ManageCurriculum",
    component: ManageCurriculum
  },
  {
    path: "/curriculum-admin",
    name: "CurriculumAdmin",
    component: CurriculumAdmin
  },
  {
    path: "/syllabus",
    name: "Syllabus",
    component: Syllabus
  },
  {
    path: "/enrollment-type",
    name: "EnrollmentType",
    component: EnrollmentType
  },
  {
    path: "/lecture-schedule",
    name: "LectureSchedule",
    component: LectureSchedule
  },
  {
    path: "/lecturer-manage-class",
    name: "CreateEditSchedule",
    component: CreateEditSchedule
  },
  {
    path: "/profile",
    name: "Profile",
    component: Profile
  },
  {
    path: "/student-status",
    name: "StudentStatus",
    component: StudentStatus
  },
  {
    path: "/study-progression",
    name: "StudyProgression",
    component: StudyProgression
  },
  {
    path: "/course-assessment",
    name: "CourseAssessment",
    component: CourseAssessment
  },
  {
    path: "/create-edit-assessment",
    name: "CreateEditAssessment",
    component: CreateEditAssessment
  },
  {
    path: "/:pathMatch(.*)*",
    name: "NotFound",
    component: NotFound
  }
];

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes
});

router.beforeEach((to, from, next) => {
  if (to.path === "/authentication" || to.path === "/authentication-manual") {
    if (localStorage.getItem("uid")) {
      next({ path: "/profile" });
    }
  } else {
    if (localStorage.getItem("uid") === null) {
      next({ path: "/authentication" });
    }
  }

  next();
});

export default router;
